--[[
==myHonor==
By Smokey aka Mahuatahu on Earthen Ring Horde US

==Version==	
1.2.8c

==To do list==
2.) (maybe?) own GUI instead of data broker --too lazy now, convenient when built into Titan Panel or FuBar
3.) BG WEEKEND
==Changelog==
1.2.8d: Fixed ANOTHER nil error. damn things.
1.2.8c: Fixed nil error from line 137.
1.2.8b: Still working on honor today and all that jazz. Fixed a nil error with Goal honor on the bar. HONOR TODAY AND SUCH IS NOT WORKING, THIS IS SEMI-INTENDED.
1.2.8: Ability to change what's on your display bar. Fixed Goal Honor Left to display N/A instead of 0.
1.2.7: Modifications to honor goal, more information for it. Msg, raid warning, and combat text when you achieve your goal.
1.2.6a - Added Honor Goal, fixed a couple misc things.
1.2.5b - Fixed another stupid nil error :(
1.2.5 - Fixed some nil errors with the on click, added some stuff for the auto join BG feature that I will soon be implementing.
1.2.1 - Fixed a couple problems with Session honor getting reset on world entrance, honor per hour modifications..
1.2.0 - Fixed couple TOC version stuffs, added Honor Per Hour!
1.1.1 - Changed to fix honor value on load.
1.1.0 - Released to public, finally a "finished product"
1.0 - Just made
--]]

--GetBattlegroundInfo(i) space 5 THIS IS FOR HOLIDAY. USE IT LATER BRO
-- with GetNumBattlegroundTypes()

local mhVersion = "1.2.8c"
local mhAddon = ...


-- Short configuration
local useSI = true					--[[	true: SI-units, e.g. 3.2k instead of 3230			]]
-- Configuration end

local suffixes = {
	"Total Honor Pts",
	"Honor Today",
	"BG Honor",
	"Honor",
}

local function siUnits(value)
	if(not useSI) then
		return value
	elseif(not value or value == 0) then
		return 0
	elseif(value >= 10^3) then
		return ("%.1fk"):format(value / 10^3)
	elseif(value >= 10^6) then
		return ("%.1fm"):format(value / 10^6)
	else
		return value
	end
end

local function texturizeIcon(arg1)
	return format("|T%s:15:15:0:0|t", type(arg1) == "number" and GetItemIcon(arg1) or arg1)
end

-- Initializing the object and frame
local honorIcon = "Interface\\PVPFrame\\PVP-Currency-"..UnitFactionGroup("player")
--local arenaIcon = [[Interface\PVPFrame\PVP-ArenaPoints-Icon]]

local OnEvent = function(self, event, ...) self[event](self, event, ...) end
local dataobj = LibStub:GetLibrary("LibDataBroker-1.1"):NewDataObject("myHonor", {
	type = "data source",
	--text = "",
	--value = "",
	icon = honorIcon,
	--suffix = "",
})
local myHonor = {}
local frame = CreateFrame"Frame"

-- [[    Update the display !    ]] --
local session, total, startTime
local startHonor, isBG
local HonorGained, SessionHonor, StartingHonor, BGHonor, LastBG, HonorBefore = 0, 0, 0, 0, 0, 0, 0, 0, 0
local HonorGained_InBG = 0
local BGCount = 0
local AvgHonor = 0
local EnteredBG = 0
local InBG = 0
local perHour = 0
local FinallyLoaded, AddonLded = nil, nil
local AutoJoinBG = nil
local LastDate = nil
local VarisLoaded = false
local myHonor_BGCONF = 0
local myHonor_BGAUTOJOINTIMER = 30
local HonorGoal = 0
local Splashed = 0
local mhDisplay = 1
local mhHonorToday, mhHonorYesterday = 0, 0
local BGTotal = 0


--[[   Initialize all variables    ]] --
function frame:PLAYER_ENTERING_WORLD()
	if(not myHonor) then
	myHonor = {}
	end
	if (not startTime) then startTime = time() end
    HonorGained = (select(2,GetCurrencyInfo(HONOR_CURRENCY)))
	  ZoneInfo = (select(2, IsInInstance()))
	  InBG = 0
	  if (ZoneInfo == "pvp") then
	     InBG = 1 --In a battleground
 	     BGCount = BGCount + 1
		 BGTotal = BGTotal + 1
	     HonorGained_InBG = HonorGained_InBG + BGHonor
	     LastBG = BGHonor
	     BGHonor = 0
         HonorBefore = (select(2,GetCurrencyInfo(HONOR_CURRENCY)))
	  else
	     InBG = 0 --Not in a battleground
	  end
	
	--if(cargoHonor.displ == 4) then dataobj.icon = [[Interface\PVPFrame\PVP-ArenaPoints-Icon]] end
	--self:CHAT_MSG_COMBAT_HONOR_GAIN()
	if (FinallyLoaded==nil) then
	self:CheckHonor()
	end
end

---------------------
--Currency updating--
---------------------
function frame:CURRENCY_DISPLAY_UPDATE()



HonorGained = (select(2,GetCurrencyInfo(HONOR_CURRENCY)))
if (FinallyLoaded==true) then
SessionHonor = (select(2,GetCurrencyInfo(HONOR_CURRENCY))) - StartingHonor
--mhHonorToday = tonumber(myHonor_HonorToday) + tonumber(SessionHonor)

if (not LastDate==string.sub(date(),0,8)) then --different day, clear honor today
	--if (string.sub(tonumber(LastDate),3,5)==(string.sub(date(),3,5)-1)) then --yesterday
	--	mhHonorYesterday = mhHonorToday
	--	mhHonorToday = 0
	--else
	--	mhHonorToday = 0
	--	mhHonorYesterday = 0
	--end
end
	

end
if (InBG==1) then
BGHonor = (select(2,GetCurrencyInfo(HONOR_CURRENCY))) - HonorBefore
end
if (BGCount>0) then
AvgHonor = HonorGained_InBG / BGCount   
end

if (Splashed==0) then

	if (HonorGoal==0) then
	--
	elseif (HonorGoal<HonorGained) then

		CombatText_AddMessage(myHonor_TXT_GOALMET, CombatText_StandardScroll, 1, 0, 0)
		RaidNotice_AddMessage(RaidWarningFrame, myHonor_TXT_GOALMET, ChatTypeInfo["RAID_WARNING"])
		DEFAULT_CHAT_FRAME:AddMessage(myHonor_TXT_GOALMET, 1, 0, 0)
		PlaySound("RaidWarning")
		Splashed = 1

	end

end

local HonorGoalFinal = 0
if (HonorGoal>0) then
	HonorGoalFinal = HonorGoal - HonorGained
end
if (HonorGoal<HonorGained) then
	HonorGoalFinal = GreenText("N/A")
end

if (mhDisplay==1) then
	dataobj.value = HonorGained
	dataobj.text = HonorGained.." Total Honor Pts"
elseif (mhDisplay==2) then
	dataobj.value = SessionHonor
	dataobj.text = SessionHonor.." Session Honor"
elseif (mhDisplay==3) then
	dataobj.value = HonorGoalFinal
	dataobj.text = HonorGoalFinal.." until Goal"
elseif (mhDisplay==4) then
	dataobj.value = BGHonor
	dataobj.text = BGHonor.." honor this BG"
elseif (mhDisplay==5) then
	dataobj.value = AvgHonor
	dataobj.text = AvgHonor.." average honor per BG"
end

end

function frame:ADDON_LOADED(arg1)

--if (arg1=="myHonor") then --good to go, set variables
if (VarisLoaded==true) then
return;
else
	if (myHonor_AJBG) then AutoJoinBG = myHonor_AJBG end
	if (myHonor_DATE) then LastDate = myHonor_DATE end
	if (myHonor_Goal) then HonorGoal = myHonor_Goal end
	if (myHonor_Display) then mhDisplay = myHonor_Display end
	--if (myHonor_HonorToday) then mhHonorToday = myHonor_HonorToday end
	--if (myHonor_HonorYesterday) then mhHonorYesterday = myHonor_HonorYesterday end
	if (mh_BGCount) then BGTotal = tonumber(mh_BGCount) end
	VarisLoaded = true
	--if (string.sub(LastDate,3,5)==(string.sub(date(),3,5)-1)) then --same day
	--	BGTotal = 0
	--	mh_BGCount = 0
	--end

end

end

function frame:PLAYER_LEAVING_WORLD()

if (Splashed==1) then
HonorGoal = 0
end

self:SaveStuff()

end

function frame:PLAYER_LOGOUT()

self:SaveStuff()

end

function frame:SaveStuff()

local TheDate = string.sub(date(),0,8)

myHonor_AJBG = AutoJoinBG
myHonor_DATE = TheDate
myHonor_Goal = HonorGoal
myHonor_Display = mhDisplay
--myHonor_HonorToday = mhHonorToday
--myHonor_HonorYesterday = mhHonorYesterday
mh_BGCount = BGTotal

end

function frame:UPDATE_BATTLEFIELD_STATUS()

--self:mhAutoBattle()

end

frame:SetScript("OnEvent", OnEvent)
frame:RegisterEvent"PLAYER_ENTERING_WORLD"
frame:RegisterEvent"PLAYER_LEAVING_WORLD"
frame:RegisterEvent"CURRENCY_DISPLAY_UPDATE"
frame:RegisterEvent"ADDON_LOADED"
frame:RegisterEvent"PLAYER_LOGOUT"
frame:RegisterEvent"UPDATE_BATTLEFIELD_STATUS"

-- [[   The tooltip  ]] --
function dataobj.OnTooltipShow(tooltip)

	 local hc, InBGtext, pname, rname, fname = 0, 0, 0, 0, 0
     pname = GetHighText(UnitName("player"))
     rname = GreenText(GetCVar("realmname"))
     fname = UnitFactionGroup("player")
     hc = GetPVPLifetimeStats()
	 local sessionTime = time() - startTime
	 local AJBGtext
	 local HonorGoalFinal, HonorGoalTime = 0, 0
     if (InBG==1) then
     	InBGtext = RedText(GetZoneText())
     	else 
     	InBGtext = GreenText("Not currently in BG")
     end
	 if (AutoJoinBG==true) then
	 	AJBGtext = "Enabled"
	 	else
	 	AJBGtext = "Disabled"
	 end
	-- Honor Stats
	if (SessionHonor>0) then
		if (startTime) then perHour = SessionHonor / sessionTime * 3600 end
	else
		perHour = 0
	end
	--xpPerHour = 
	if (fname=="Alliance") then
        fname = BlueText(UnitFactionGroup("player"))
     else
        fname = RedText(UnitFactionGroup("player"))
     end
	 if (HonorGoal>0) then
	 	HonorGoalFinal = HonorGoal - HonorGained
		if (BGCount>0) then
			if (AvgHonor>0) then
				HonorGoalTime = HonorGoalFinal/AvgHonor
				HonorGoalTime = format("%d",HonorGoalTime)
			else
				HonorGoalTime = "N/A"
			end
		else
			HonorGoalTime = "N/A"
		end
	 else
	 	HonorGoalFinal = "N/A"
	 end
	 if (HonorGoal==0) then
	 HonorGoalTime = GetHighText("N/A")
	 elseif (HonorGoal<HonorGained) then
		HonorGoalFinal = GreenText("Goal Accomplished!")
	 end
	-- Arena points
	--local arena = GetArenaCurrency()
	--if(arena > 0) then
	--	tooltip:AddDoubleLine("Arena points:", arena.." "..texturizeIcon(arenaIcon), 1,1,1, 0,1,0)
	--end
	tooltip:AddLine(pname.." - "..rname.." ("..fname..")")
	tooltip:AddLine(mhAddon.." v"..mhVersion)
	tooltip:AddLine(" ")
	tooltip:AddDoubleLine(myHonor_TT_STATUS,InBGtext)
	tooltip:AddDoubleLine(myHonor_TT_SESSIONPTS,Should_I_Be_Red(SessionHonor))
	tooltip:AddDoubleLine(myHonor_TT_TOTALPTS,GetHighText(StartingHonor))
	tooltip:AddDoubleLine(myHonor_TT_TOTALHKS,GetHighText(hc))
	tooltip:AddDoubleLine(myHonor_TT_TODAYPTS,GetHighText(mhHonorToday))
	tooltip:AddDoubleLine(myHonor_TT_YESPTS,GetHighText(mhHonorYesterday))
	tooltip:AddLine(" ")
	tooltip:AddLine("----------------------------------")
	tooltip:AddLine(" ")
	tooltip:AddDoubleLine(GetHighText(myHonor_TT_BGSTATS))
	tooltip:AddLine(" ")
	tooltip:AddDoubleLine(myHonor_TT_LASTBG,Should_I_Be_Red(LastBG))
	tooltip:AddDoubleLine(myHonor_TT_BGHONOR,Should_I_Be_Red(BGHonor))
	tooltip:AddDoubleLine(myHonor_TT_AVGHONOR,Should_I_Be_Red(format("%d",AvgHonor)))
	tooltip:AddDoubleLine(myHonor_TT_BGCOUNT,Should_I_Be_Red(BGCount))
	tooltip:AddDoubleLine(myHonor_TT_BGTTL,Should_I_Be_Red(BGTotal))
	tooltip:AddDoubleLine(myHonor_TT_PERHR,Should_I_Be_Red(format("%d",perHour)))
	tooltip:AddLine("----------------------------------")
	tooltip:AddDoubleLine(myHonor_TT_GOALTEXT,GreenText(HonorGoal))
	tooltip:AddDoubleLine(myHonor_TT_GOALTEXT2,GetHighText(HonorGoalFinal))
	tooltip:AddDoubleLine(myHonor_TT_GOALTIME,GreenText("~"..HonorGoalTime))
	tooltip:AddLine("----------------------------------")
	tooltip:AddDoubleLine(myHonor_TT_AJBG, GetHighText(AJBGtext))
	tooltip:AddLine(" ")
	tooltip:AddLine(myHonor_TT_CLICKTOGGLE)
	tooltip:AddLine(myHonor_TT_CLICKPVP)
	tooltip.updateFunction = dataobj.OnTooltipShow
end

SLASH_GOAL1 = "/goal"
function SlashCmdList.GOAL(msg)

local cmd = msg:lower()

if (cmd=="") then
	
	DEFAULT_CHAT_FRAME:AddMessage(myHonor_TXT_GOALSYN, 1, 1, 0)

elseif (tonumber(msg)>40000) then

	DEFAULT_CHAT_FRAME:AddMessage(myHonor_TXT_GOALERR, 1, 1, 0)
	
else

	HonorGoal = tonumber(msg)
	DEFAULT_CHAT_FRAME:AddMessage(myHonor_TXT_GOALSET..HonorGoal, 1, 1, 0)
	Splashed = 0
	if (mhDisplay==3) then
	local HonorGoalFinal = 0
	if (HonorGoal>0) then
		HonorGoalFinal = HonorGoal - HonorGained
	end
	if (HonorGoal<HonorGained) then
		HonorGoalFinal = GreenText("N/A")
	end
		dataobj.value = HonorGoalFinal
		dataobj.text = HonorGoalFinal.." until Goal"
	end
	
end

end

SLASH_AJBG1 = "/mh"
function SlashCmdList.AJBG(msg)
local cmd = msg:lower()

if (cmd=="aj") then
frame:CallAJBG()
elseif (cmd=="goal") then
DEFAULT_CHAT_FRAME:AddMessage(myHonor_TXT_GOALSYN, 1, 1, 0)
elseif (cmd=="help") then
DEFAULT_CHAT_FRAME:AddMessage("myHonor Help \n hi", 1, 1, 0)
DEFAULT_CHAT_FRAME:AddMessage("Honor Goal: \"/goal #\"; Auto Join BG Toggle: \"/mh aj\"", 1, 1, 0)
DEFAULT_CHAT_FRAME:AddMessage("myHonor Version: "..mhVersion, 1, 1, 0)
end

end

function frame:CallAJBG()

if (AutoJoinBG==true) then
	AutoJoinBG=false
	else
	AutoJoinBG=true
end

end

function dataobj.OnClick(self, button)
	if(button == "RightButton") then
		TogglePVPFrame()
	else
		if (mhDisplay==5) then
			mhDisplay = 1
		else
			mhDisplay = mhDisplay + 1
		end
		frame:CURRENCY_DISPLAY_UPDATE()

	end
end

function GreenText(text)

	if (text) then
		return "|cff00ff00"..text.."|r"
	end 

end

function RedText(text)

	if (text) then
		return "|cffff0000"..text.."|r"
	end 

end

function BlueText(text)

	if (text) then
		return "|cff0000ff"..text.."|r"
	end 

end

function GetHighText(text)

	if (text) then
		return "|cffffffff"..text.."|r"
	end

end

function Should_I_Be_Red(text)
	if (text) then
		if (tonumber(format("%d",text))<=0) then
			return RedText(text)
		else
			return GreenText(text)
		end
	end
end

function frame:CheckHonor()

if (FinallyLoaded==nil) then
StartingHonor = (select(2,GetCurrencyInfo(HONOR_CURRENCY)))
FinallyLoaded = true
end

end

function frame:mhAutoBattle()
	local autoJoin = AutoJoinBG	
	local status, index
	local go = 0

	for i=1,MAX_BATTLEFIELD_QUEUES do
		status = (select(1,GetBattlefieldStatus(i)))
		if(status == "confirm") then
			index = i
			if (autoJoin == true) then
				go = 1
			else
				go = 0
			end
			break
		elseif (status == "active") then
			index = i
			go = 0
			break
		elseif (status == "none") then
			index = i
			go = 0
			break
		end	
	end
		if (go == 1) then
			if (myHonor_BGCONF == 0) then
				DEFAULT_CHAT_FRAME:AddMessage(myHonor_TXT_AUTOJOIN, 1, 1, 0)
				myHonor_BGCONF = (select(1,GetTime())) + myHonor_BGAUTOJOINTIMER
			end
			if (math.floor(myHonor_BGCONF - (select(1,GetTime()))) == 19) then DEFAULT_CHAT_FRAME:AddMessage("20...", 1, 1, 0) end
			if (math.floor(myHonor_BGCONF - (select(1,GetTime()))) == 9) then DEFAULT_CHAT_FRAME:AddMessage("10...", 1, 1, 0) end
			if (math.floor(myHonor_BGCONF - (select(1,GetTime()))) == 4) then DEFAULT_CHAT_FRAME:AddMessage("5...", 1, 1, 0) end
			if (math.floor(myHonor_BGCONF - (select(1,GetTime()))) == 3) then DEFAULT_CHAT_FRAME:AddMessage("4...", 1, 1, 0) end
			if (math.floor(myHonor_BGCONF - (select(1,GetTime()))) == 2) then DEFAULT_CHAT_FRAME:AddMessage("3...", 1, 1, 0) end
			if (math.floor(myHonor_BGCONF - (select(1,GetTime()))) == 1) then DEFAULT_CHAT_FRAME:AddMessage("2...", 1, 1, 0) end
			if (math.floor(myHonor_BGCONF - (select(1,GetTime()))) == 0) then DEFAULT_CHAT_FRAME:AddMessage("1...", 1, 1, 0) end
		end
		
	if (go == 1) then
		if (StaticPopup_Visible("CONFIRM_BATTLEFIELD_ENTRY")) then
			--if ((select(1,GetTime())) > myHonor_BGCONF) then
				myHonor_BGCONF = 0
				if UnitIsAFK("player") then
					DEFAULT_CHAT_FRAME:AddMessage(myHonor_TXT_CANCELJOIN, 1, 1, 0)
					--AcceptBattlefieldPort(index, 0)
				elseif (status == "active") then
					DEFAULT_CHAT_FRAME:AddMessage("Auto-Joining canceled.", 1, 1, 0)
					AcceptBattlefieldPort(index, 0)
				elseif (status == "none") then
					DEFAULT_CHAT_FRAME:AddMessage("Auto-Joining canceled.", 1, 1, 0)
					AcceptBattlefieldPort(index, 0)
				elseif (status == "confirm") then
					DEFAULT_CHAT_FRAME:AddMessage(myHonor_TXT_NOWJOIN, 1, 1, 0)
					AcceptBattlefieldPort(index, 1)
				else
					DEFAULT_CHAT_FRAME:AddMessage(myHonor_TXT_UNKNOWNAJ, 1, 1, 0)
					AcceptBattlefieldPort(index, 0)
				end
				StaticPopup_Hide("CONFIRM_BATTLEFIELD_ENTRY")
			--end
		end
	end
end

--word, opyright Smokey, 2010 All Rights Reserved, released under GNU License #3.
--if you're going to edit, at least give me credit or tell me about it and we can work together
--2010